package bookmark;

import java.awt.Color;
import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.UIManager;

import com.japisoft.xmlpad.XMLContainer;
import com.japisoft.xmlpad.editor.XMLDocument;
import com.japisoft.xmlpad.bookmark.BookmarkContext;
import com.japisoft.xmlpad.bookmark.BookmarkModel;
import com.japisoft.xmlpad.bookmark.BookmarkPosition;
import com.japisoft.xmlpad.bookmark.DefaultBookmarkContext;

/**
 * Here a sample of usage for the bookmark API part.
 * @author (c) 2004 JAPISoft / http://www.japisoft.com
 * @version 1.0
 * */
public class DemoBookmark extends JFrame {

    private BookmarkContext bookmarks;
    private XMLContainer container;
	
    public DemoBookmark() {

	container = new XMLContainer();
	container.setBookmarkContext(
				     bookmarks = new DefaultBookmarkContext(
									    new ImageIcon( getClass().getResource( "bookmark.gif" ) ),
									    new Color( 200, 200, 250 ) ) );
		
	container.getToolBarModel().addAction(
					      new ListBookmarks() );
		
	getContentPane().add( container.getView() );
		
    }

    // Action that lists the "bookmarked" lines
    class ListBookmarks extends AbstractAction {

	public ListBookmarks() {
	    putValue( 
		     Action.SMALL_ICON, 
		     new ImageIcon( getClass().getResource( "bookmark.gif" ) ) );
	}

	public void actionPerformed( ActionEvent e ) {
			
	    XMLDocument doc = container.getDocument();
			
	    BookmarkModel model = bookmarks.getModel();
	    for ( int i = 0; i < model.getBookmarkCount(); i++ ) {
		BookmarkPosition pos = model.getBookmarkPositionAt( i );
		int offset = pos.getOffset();
		int line = doc.getDefaultRootElement().getElementIndex( offset );
		System.out.println( "Bookmark at " + line );
	    }

	}

    }

    public static void main(String[] args) {
	try {
	    UIManager.setLookAndFeel( 
				     UIManager.getSystemLookAndFeelClassName() );
	} catch( Exception exc ) {
	}
		
	DemoBookmark frame = new DemoBookmark();
	frame.setBounds( 10, 10, 600, 400 );
	frame.setVisible( true );
		
    }

}
